/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_insn.h 8 2008-05-24 17:01:12Z roi $
 */

/*
 *		ƥü̿Υ饤ؿH8/300Hѡ
 */

#ifndef	TOPPERS_CORE_INSN_H
#define	TOPPERS_CORE_INSN_H

#include "h8300h_gcc/h8300h.h"

/*
 *  ǥ󥳡ɥ쥸CCRˤθͤɽФ
 *uint8_t current_ccr(void);
 *unsigned char get_ccr(void);
 */
Inline uint8_t
current_ccr(void)
{
    uint8_t	ccr;
    Asm("stc.b ccr,%0l" : "=r"(ccr));
    return(ccr);
}

/*
 *  ǥ󥳡ɥ쥸CCRˤθͤѹ
 */
Inline void
set_ccr(uint8_t ccr)
{
	Asm("ldc.b %0l, ccr" : : "r"(ccr) :"memory");
}

/*
 *  NMI٤Ƥγߤػ
 */
Inline void
disint(void)
{
    Asm("orc #0xc0,ccr":::"memory");
}

/*
 *  ٤Ƥγߤ
 */
Inline void
enaint(void)
{
    Asm("andc #0x3f,ccr":::"memory");
}


/*
 * ӥåȤΥåȤȥꥢ
 * bset̿bclr̿᤬뤬饤󥢥֥θƤӽФ
 * Сإåɤ̵ǤʤΤǡCʬ䤹ҤƤ롣
 *
 * ׸Ƥɤ߽ФȽ񤭹ߤδ֤ǳߤ
 */

/*
 * ӥåȤ򥯥ꥢ
 */
Inline void
bitclr (uint8_t *addr, uint8_t bit)
{
    Asm("bclr %1l, @%0" : : "r"(addr), "r"(bit));
}

/*
 * ӥåȤ򥻥å
 */
Inline void
bitset (uint8_t *addr, uint8_t bit)
{
    Asm("bset %1l, @%0" : : "r"(addr), "r"(bit));
}


/*
 *  ǥ塼ΤΥӥåȥޥåץؿ
 *
 *  ǥեȤΥӥåȥޥåץؿѤ롣
 */
/* #define OMIT_BITMAP_SEARCH */

#endif /* TOPPERS_CORE_INSN_H */
